import 'package:flutter/material.dart';
import 'package:flutter/services.dart';
import 'package:kameleoon_client_flutter/kameleoon_client.dart';
import 'package:kameleoon_client_flutter/kameleoon_exceptions.dart' as KameleoonExceptions;
import 'package:kameleoon_client_flutter_example/Pages/Main/main_page.dart';
import 'package:kameleoon_client_flutter_example/constants.dart';

void main() {
  runApp(MyApp());
}

class MyApp extends StatefulWidget {
  @override
  _MyAppState createState() => _MyAppState();
}

class _MyAppState extends State<MyApp> {
  @override
  void initState() {
    super.initState();
    initKameleoon();
  }

  Future<void> initKameleoon() async {
    KameleoonClient client = await KameleoonClient.create("yjiu8jw554");

    client.runWhenReady(() async {
      print("SUCCESS");
      String visitorCode = await client.obtainVisitorCode();
      try {
        bool ff = await client.activateFeature(visitorCode, "color-feature-flag");
        if (ff) {
          String color = await client.obtainFeatureVariable("color-feature-flag", "color");
          color = "FF" + color.toUpperCase().replaceAll("#", "");
          //mainColor = Color(int.parse(color, radix: 16));
        }
      } on KameleoonExceptions.FeatureConfigurationNotFound {
      } on KameleoonExceptions.NotTargeted {
      } on PlatformException {
      }
    }, () {
      print("TIMEOUT");
    }, 1000);
  }

  @override
  Widget build(BuildContext context) {
    return MaterialApp(
      title: "Kameleoon Plugin Demo",
      theme: ThemeData(
        primaryColor: mainColor,
        scaffoldBackgroundColor: bgColor
      ),
      home: MainPage(),
      debugShowCheckedModeBanner: false,
    );
  }
}
